var db = require('../models/schema');
var util = require('../util/util');
var log = require('../lib/logger.js');
var config = require('../config/config');
var uid = require('node-uuid');
var validator = require('validator');
var smsService = require('../smsservice/sms');
var emailService = require('../emailservice/emailservice');
var room = require('../chatComm/room.js');

const IOS = "iOS";
const ANDROID = "Android";

module.exports.getServerTime = function(req, res) {
        try {
            res.status(200).json({
                'servertime': util.getCurrentTimestamp()
            });

        } catch (err) {
            log.error("error in getServerTime:" + err);
            res.status(500).json({
                'error': 'error in getServerTime'
            });
        }
    }
    //Registers a new user
    //param:firstname,lastname,primaryemail,devicetoken
module.exports.register = function(req, res) {
    try {
        log.info("Register req: " + req.body.firstname + "::" + req.body.loginkey);
        var Fname = req.body.firstname;
        var Lname = req.body.lastname;
        var uuId = req.body.uuid;
        var basicProfileDetails = [],
            otherMails = [],
            contactNo = [],
            companyName = [],
            socialMedia = [];
        var loginKey = req.body.loginkey;
        otherMails = req.body.othermails;
        companyName = req.body.companyname;
        socialMedia = req.body.socialmedia;
        var contactNumber = req.body.contactnumber || "";
        var deviceType = req.body.devicetype;
        var deviceToken = req.body.devicetoken;
        var mailSendStatus = [];
        var tokenGenerated = Math.floor(Math.random() * 1000000);
        if ((tokenGenerated + "").length < 6) {
            log.info("Register token length is less that 6");
            tokenGenerated = tokenGenerated + 100000;
        }
        var userIdGenerated = uid.v1();

        log.info('Login info' + loginKey);
        var primaryEmail = "";
        var primaryContactNumber = "";
        var contactnumberTopersist = [];
        var adminEmails = [];
        adminEmails[0] = config.adminemail;
        var emailTopersist = [];
        if (validator.isEmail(loginKey) == true) {
            primaryEmail = loginKey;
            emailTopersist = [{
                "value": loginKey,
                "visibleToPublic": true,
                "type": "primary",
                "label": "work",
                "verified": true,
                "deleted": false,
                "invitecode": ""
            }];

        } else {
            primaryContactNumber = loginKey;
            contactnumberTopersist = [{
                "value": loginKey,
                "visibleToPublic": false,
                "type": "primary",
                "label": "mobile",
                "verified": true,
                "deleted": false,
                "invitecode": ""
            }];
        }
        var summary = {
            description: "",
            visibleToPublic: ""
        };
        var profileimage = {
            profileImageUrl: "",
            visibleToPublic: ""
        };
        var ogurl = "";
        var userName = {
            "firstname": Fname,
            "lastname": Lname
        }; //req.body.username;
        //var email = [{"value":"","visibleToPublic":true,"type":"primary","label":"work","verified":true,"deleted":false}];
        var time = util.getCurrentTimestamp();
        log.info("Recieving uuid is:" + req.body.uuid);
        var deviceDetails = [{
            "devicetype": deviceType,
            "devicetoken": deviceToken,
            "uuid": uuId,
            "inuse": true,
            "laststatuschange": time,
            "token": tokenGenerated,
            "tokenValidated": false
        }];
        log.info("register payload " + deviceToken);
        var tokenStatus;
        db.profiles.findOne( /*{$or:[{'email':{$elemMatch:{'value':loginKey}}},*/ {
            loginkey: loginKey
        } /*]}*/ , function(err, profile) {
            if (err) {
                log.error(err);
            } else {
                if (!profile) {
                    log.info("Profile Not found");
                    var register = new db.profiles({
                        username: userName,
                        email: emailTopersist,
                        contactnumber: contactnumberTopersist,
                        primarycontactnumber: primaryContactNumber,
                        primaryemail: primaryEmail,
                        deviceInfo: deviceDetails,
                        status: 'offline',
                        validprofile: false,
                        timestamp: time,
                        userId: userIdGenerated,
                        loginkey: loginKey,
                        summary: summary,
                        profileimage: profileimage,
                        ogurl: ogurl
                    });
                    register.save(function(err, result) {
                        if (err) {
                            log.info('error:', err);
                        } else {
                            // log.info({'result':result});
                            res.status(200);
                            res.json({
                                'status': 'Registration success',
                                'response': result
                            });
                            var emailTemplateData = {
                                name: Fname + " " + Lname,
                                token: tokenGenerated,
                                host: config.HostName,
                                invitedthrough: "register",
                                roomid: "",
                                members: "",
                                userid: "",
                                token: tokenGenerated
                            };
                            if (validator.isEmail(loginKey) == true) {
                              emailService.mailSender(Fname, loginKey, tokenGenerated, 'register' , emailTemplateData, function(result) {
                                  log.info('Email send status:' + result);
                              });
                            }
                            else{
                              smsService.sendSMS(loginKey, emailTemplateData, function(smsStatus) {
                                  log.info('SMS send status:' + smsStatus);
                              });
                            }
                            log.info('update result:' + JSON.stringify(result));
                        }
                    });
                    util.auditlog(userIdGenerated, 'Registration');
                    setTimeout(checkTokenExpiry, config.tokenExpiryTime, userIdGenerated, loginKey, uuId);
                } else {
                    log.info("Existing profile found");
                    tokenStatus = profile.validprofile;
                    log.info("profile token status :" + tokenStatus);
                    if (tokenStatus == true) {
                        res.status(400).json({
                            'status': 'This number is already registered. Please use a different number'
                        });
                    } else {
                        db.profiles.update({
                            loginkey: loginKey
                        }, {
                            username: userName,
                            email: emailTopersist,
                            contactnumber: contactnumberTopersist,
                            primarycontactnumber: primaryContactNumber,
                            primaryemail: primaryEmail,
                            deviceInfo: deviceDetails,
                            status: 'offline',
                            validprofile: false,
                            timestamp: time,
                            userId: userIdGenerated,
                            summary: summary,
                            profileimage: profileimage,
                            ogurl: ogurl
                        }, function(err, result) {
                            if (err) {
                                log.info('error in update profiles:' + err);
                            } else {
                                log.info("updated the profile :" + result);
                                log.info({
                                    'result': result
                                });
                                res.status(200);
                                profile.token = tokenGenerated;
                                profile.userId = userIdGenerated;
                                res.json({
                                    'status': 'Registration success',
                                    'response': profile
                                });
                                var emailTemplateData = {
                                    name: Fname + " " + Lname,
                                    token: tokenGenerated,
                                    host: config.HostName,
                                    invitedthrough: "register",
                                    roomid: "",
                                    members: "",
                                    token: tokenGenerated
                                };
                                if (validator.isEmail(loginKey) == true) {
                                  emailService.mailSender(Fname, loginKey, tokenGenerated, 'register' , emailTemplateData, function(result) {
                                      log.info('Email send status:' + result);
                                  });
                                }
                                else{
                                  smsService.sendSMS(loginKey, emailTemplateData, function(smsStatus) {
                                      log.info('SMS send status:' + smsStatus);
                                  });
                                }

                                log.info('update result:' + JSON.stringify(result));
                            }
                        });
                        util.auditlog(userIdGenerated, 'Registration');
                        setTimeout(checkTokenExpiry, config.tokenExpiryTime, userIdGenerated, loginKey, uuId);
                    }
                }
            }
        });

    } catch (err) {
        log.error("error in Register:" + err);
        res.status(500).json({
            'error': 'error in Register'
        });
    }
};

//Validates the token supplied from the FE
//param:token,deviceToken
module.exports.validateToken = function(req, res) {
    try {
        log.info("validateToken method begins its execution ...");
        var loginKey = req.body.loginkey;
        var recvdToken = req.body.token;
        var uuId = req.body.uuid;
        var time = util.getCurrentTimestamp();
        var adminEmails = [];
        adminEmails[0] = config.adminemail;
        db.profiles.findOne({
            $and: [{
                loginkey: loginKey
            }, {
                'deviceInfo': {
                    $elemMatch: {
                        'uuid': uuId
                    }
                }
            }]
        }, function(err, result) {
            if (err) {
                log.error(err);
            } else {
                if (!result) {
                    log.info("Token not found:");
                    res.status(417).json({
                        'status': 'Invalid token'
                    });
                } else {
                    var resultObtained = result;

                    validateDevice(resultObtained.deviceInfo, uuId, function(deviceStatus, index) {
                        if (deviceStatus && resultObtained.deviceInfo[index].token == recvdToken) {
                            log.info("token validated successfully for userid :" + resultObtained.userId);
                            var deviceToAvoid = IOS
                            var deviceFound = resultObtained.deviceInfo[index].devicetype;
                            if (deviceFound == IOS) {
                                deviceToAvoid = ANDROID;
                            }
                            CreateSelfRoomData(resultObtained);
                            res.json({
                                'status': 'token validated successfully',
                                'userid': resultObtained.userId,
                                'username': resultObtained.username,
                                'loginkey': resultObtained.loginkey
                            });
                            log.info("validateToken: token is valid");
                            db.profiles.update({
                                $and: [{
                                    loginkey: loginKey
                                }, {
                                    'deviceInfo': {
                                        $elemMatch: {
                                            'uuid': uuId
                                        }
                                    }
                                }]
                            }, {
                                'deviceInfo.$.tokenValidated': true,
                                timestamp: time,
                                status: 'online',
                                validprofile: true
                            }, function(err, tokenUpdated) {
                                if (err) {
                                    log.error(err);
                                } else {
                                    if (!tokenUpdated) {
                                        log.info("validateToken update, No result found");
                                    } else {
                                        log.info("validateToken updated");
                                        if (resultObtained) {
                                            //Update attendees list if he is in any chatroom

                                            db.chatGroup.update({
                                                'attendees': {
                                                    $elemMatch: {
                                                        'contact': resultObtained.loginkey
                                                    }
                                                }
                                            }, {
                                                $set: {
                                                    "attendees.$.userid": resultObtained.userId,
                                                    "attendees.$.username": resultObtained.username.firstname + " " + resultObtained.username.lastname,
                                                    "attendees.$.jointime": time,
                                                    "attendees.$.lastremaindertime": "",
                                                    "attendees.$.profile_id": resultObtained._id
                                                }
                                            }, {
                                                multi: true
                                            }, function(err, result) {
                                                if (err) {
                                                    log.info('error in update attendees:' + err);
                                                } else {
                                                    log.info("validateToken updated the attendees :" + JSON.stringify(result));
                                                    //updating attendeesBackup to return praivate chat roomid
                                                    db.chatGroup.update({
                                                        'attendeesBackUp': {
                                                            $elemMatch: {
                                                                'contact': resultObtained.loginkey
                                                            }
                                                        }
                                                    }, {
                                                        $set: {
                                                            "attendeesBackUp.$.userid": resultObtained.userId,
                                                            "attendees.$.username": resultObtained.username.firstname + " " + resultObtained.username.lastname,
                                                            "attendeesBackUp.$.jointime": time,
                                                            "attendees.$.lastremaindertime": "",
                                                            "attendeesBackUp.$.profile_id": resultObtained._id
                                                        }
                                                    }, {
                                                        multi: true
                                                    }, function(err, result) {
                                                        if (err) {
                                                            log.info('validateToken error in update attendeesBackUp:' + err);
                                                        } else {
                                                            log.info("validateToken updated the attendeesBackUp :" + JSON.stringify(result));

                                                        }
                                                    });
                                                }
                                            });
                                        } else {
                                            log.info('acceptanceDetails: NO profiles found');
                                        }

                                    }
                                }

                            });
                            util.auditlog(resultObtained.userId, 'validateToken');
                        } else if (deviceStatus && resultObtained.deviceInfo[index].token == "expired") {
                            log.info("Token Expired ");
                            res.status(417).json({
                                'status': 'token expired'
                            });
                        } else {
                            log.info("Token NOT matching ");
                            res.status(417).json({
                                'status': 'Invalid token'
                            });
                        }
                    });
                }
            }
        });
    } catch (err) {
        log.error("error in validateToken:" + err);
        res.status(500).json({
            'error': 'error in validateToken'
        });
    }
}

//Cheks if the provided emailid is existing profiles
//param:primaryemail,devicetoken
module.exports.signIn = function(req, res) {
    try {
        log.info("sign in method execution begins ...");
        log.info("sign in req :" + req.body.loginkey + "uuid" + req.body.uuid);
        var loginKey = req.body.loginkey;
        var uuId = req.body.uuid;
        var deviceType = req.body.devicetype;
        var deviceToken = req.body.devicetoken;
        var adminEmails = [];
        adminEmails[0] = config.adminemail;
        log.info("device token : " + req.body.devicetoken + " TYPE: " + req.body.devicetype);

        var query = "online";
        var statusTimequery = util.getCurrentTimestamp();
        //Validate the email first and then check the device in use,
        //if defferent device then email notify the update/replace device
        db.profiles.findOne({
            loginkey: loginKey
        }, function(err, result) {
            if (err) {
                log.error(err);
            } else {
                if (!result) {
                    log.info("signIn profile NOT found");
                    res.status(417).json({
                        'status': 'Invalid login'
                    });
                } else {
                    var resultObtained = result;
                    log.info("signIn profile found");
                    if (resultObtained.validprofile == true) {
                        //check the device uuid
                        validateDevice(resultObtained.deviceInfo, uuId, function(deviceStatus, index) {
                            if (deviceStatus) {
                                log.info("device details:" + JSON.stringify(resultObtained.deviceInfo[index].tokenValidated));
                                if (resultObtained.deviceInfo[index].tokenValidated == true) {
                                    //change status:update status into online
                                    changestatus(resultObtained.userId, query, statusTimequery);
                                    //Existing device!, allow the user to sign-in/login
                                    log.info("Existing device!, allow the user to sign-in/login:" + resultObtained.userId);
                                    var deviceDetails = [{
                                        "devicetype": deviceType,
                                        "devicetoken": deviceToken,
                                        "uuid": uuId,
                                        "inuse": true,
                                        "laststatuschange": statusTimequery,
                                        "token": resultObtained.deviceInfo[index].token,
                                        "tokenValidated": true
                                    }];
                                    db.profiles.update( /*{$or:[{'email':{$elemMatch:{'value':loginKey}}},*/ {
                                        loginkey: loginKey
                                    } /*]}*/ , {
                                        'deviceInfo': deviceDetails
                                    }, function(err, result) {
                                        if (err) {
                                            log.info('Signin: error in update profiles:' + err);
                                        } else {
                                            log.info("Signin: updated the profile :" + result);
                                        }
                                    });
                                    var deviceToAvoid = IOS;
                                    var deviceFound = resultObtained.deviceInfo[index].devicetype;
                                    if (deviceFound == IOS) {
                                        deviceToAvoid = ANDROID;
                                    }
                                    res.json({
                                        'status': 'Signin success',
                                        'userid': resultObtained.userId,
                                        'username': resultObtained.username,
                                        'loginkey': resultObtained.loginkey
                                    });
                                    util.auditlog(resultObtained.userId, 'User Signin in existing device');
                                } else {
                                    //New device!, Token would have expired or not validated yet update othe device: Ask the user for a confirmation for new token
                                    log.info("User signin from new device,token yet to be validated:" + resultObtained.userId);
                                    var tokenGenerated = Math.floor(Math.random() * 1000000);
                                    if ((tokenGenerated + "").length < 6) {
                                        log.info("Signin:Devive update: token length is less that 6");
                                        tokenGenerated = tokenGenerated + 100000;
                                    }
                                    db.profiles.update({
                                        $and: [{
                                            loginkey: loginKey
                                        }, {
                                            'deviceInfo': {
                                                $elemMatch: {
                                                    'uuid': uuId
                                                }
                                            }
                                        }]
                                    }, {
                                        'deviceInfo.$.tokenValidated': false,
                                        "deviceInfo.$.devicetype": deviceType,
                                        "deviceInfo.$.devicetoken": deviceToken,
                                        "deviceInfo.$.inuse": false,
                                        "deviceInfo.$.laststatuschange": statusTimequery,
                                        "deviceInfo.$.token": tokenGenerated
                                    }, function(err, result) {
                                        if (err) {
                                            log.info('Signin: error in update profiles:' + err);
                                        } else {
                                            log.info("Signin: updated the profile :" + result);
                                            res.json({
                                                'status': 'New device',
                                                'userid': resultObtained.userId,
                                                'username': resultObtained.username,
                                                'loginkey': resultObtained.loginkey
                                            });
                                            //Email notify the user for validating the token
                                            var emailTemplateData = {
                                                name: resultObtained.username.firstname + " " + resultObtained.username.lastname,
                                                token: tokenGenerated,
                                                host: config.HostName,
                                                invitedthrough: "validateDevice",
                                                roomid: "",
                                                members: ""
                                            };
                                            if (validator.isEmail(loginKey) == true) {
                                              emailService.mailSender(resultObtained.username.firstname, loginKey, tokenGenerated, 'validateDevice' , emailTemplateData, function(result) {
                                                  log.info('Email send status:' + result);
                                              });
                                            }
                                            else{
                                              smsService.sendSMS(loginKey, emailTemplateData, function(smsStatus) {
                                                  log.info('SMS send status:' + smsStatus);
                                              });
                                            }


                                        }
                                    });
                                    util.auditlog(resultObtained.userId, 'User signin from new device');
                                    setTimeout(checkTokenExpiry, config.tokenExpiryTime, resultObtained.userId, loginKey, uuId);
                                }
                            } else {
                                //New device!, update or replace the device: Ask the user for a confirmation
                                log.info("User signin from new device:" + resultObtained.userId);
                                var tokenGenerated = Math.floor(Math.random() * 1000000);
                                if ((tokenGenerated + "").length < 6) {
                                    log.info("Signin:Devive update: token length is less that 6");
                                    tokenGenerated = tokenGenerated + 100000;
                                }
                                var deviceDetails = {
                                    "devicetype": deviceType,
                                    "devicetoken": deviceToken,
                                    "uuid": uuId,
                                    "inuse": false,
                                    "laststatuschange": statusTimequery,
                                    "token": tokenGenerated,
                                    "tokenValidated": false
                                };
                                db.profiles.update( /*{$or:[{'email':{$elemMatch:{'value':loginKey}}},*/ {
                                    loginkey: loginKey
                                } /*]}*/ , {
                                    '$addToSet': {
                                        'deviceInfo': deviceDetails
                                    }
                                }, function(err, result) {
                                    if (err) {
                                        log.info('Signin: error in update profiles:' + err);
                                    } else {
                                        log.info("Signin: updated the profile :" + result);
                                        res.json({
                                            'status': 'New device',
                                            'userid': resultObtained.userId,
                                            'username': resultObtained.username,
                                            'loginkey': resultObtained.loginkey
                                        });
                                        //Email notify the user for validating the token
                                        var emailTemplateData = {
                                            name: resultObtained.username.firstname + " " + resultObtained.username.lastname,
                                            token: tokenGenerated,
                                            host: config.HostName,
                                            invitedthrough: "validateDevice",
                                            roomid: "",
                                            members: ""
                                        };

                                        smsService.sendSMS(loginKey, emailTemplateData, function(smsStatus) {
                                            log.info('SMS send status:' + smsStatus);
                                        });
                                    }
                                });
                                util.auditlog(resultObtained.userId, 'User signin from new device');
                                setTimeout(checkTokenExpiry, config.tokenExpiryTime, resultObtained.userId, loginKey, uuId);
                            }
                        });
                    } else {
                        log.info("signIn profile found: Token yet to be validated");
                        res.status(417).json({
                            'status': 'Validate token'
                        });
                    }
                }
            }
        });
    } catch (err) {
        log.error("error in signIn:" + err);
        res.status(500).json({
            'error': 'error in signIn'
        });
    }
}


function validateDevice(deviceInfo, uuid, callback) {
    var totalDevices = deviceInfo.length;
    var index = 0;
    var deviceFound = false;
    sendResponse = function(totalCount, iteration) {
        if (iteration == totalCount - 1) {
            log.info('sendResponse: The device is ' + deviceFound);
            callback(deviceFound, index);
        }
    }

    checkDeviceUuid = function(Duuid, count, total, uuid) {
        if (Duuid == uuid) {
            //Existing device allow the user to sign-in/login
            log.info('checkDeviceUuid: Found the device:');
            deviceFound = true;
            index = count;
            sendResponse(total, count);
        } else {
            log.info('checkDeviceUuid: NOT Found the device:');
            sendResponse(total, count);
        }
    }
    for (var i = 0; i < totalDevices; i++) {
        checkDeviceUuid(deviceInfo[i].uuid, i, totalDevices, uuid);
    }
}

function changestatus(userid, query, statusTimequery) {
    var statusupdatetime = JSON.stringify(statusTimequery);
    db.profiles.update({
        'userId': userid
    }, {
        "status": query,
        "statusupdatetime": statusupdatetime
    }, function(err, result) {
        if (err) {
            log.info('changestatus: error in changing status:' + err);
        } else {
            log.info("changestatus: status updated :" + JSON.stringify(result));
            util.auditlog(userid, 'status change :' + query);
        }
    });
}

module.exports.reSendOTP = function(req, res) {
    try {
        log.info("resendOTP method executes..");
        var loginKey = req.body.loginkey;
        var userID = req.body.userid;
        var uuID = req.body.uuid;

        var tokenGenerated = Math.floor(Math.random() * 1000000);
        if ((tokenGenerated + "").length < 6) {
            log.info("resendOTP token length is less that 6");
            tokenGenerated = tokenGenerated + 100000;
        }

        db.profiles.update({
            $and: [{
                loginkey: loginKey
            }, {
                'deviceInfo': {
                    $elemMatch: {
                        'uuid': uuID
                    }
                }
            }]
        }, {
            'deviceInfo.$.tokenValidated': false,
            'deviceInfo.$.token': tokenGenerated
        }, function(err, updatedResult) {
            if (err) {
                log.error("reSendOTP:Error in finding the profile" + err);
                res.status(417).json({
                    'status': 'Invalid loginkey',
                    'loginkey': loginKey
                });
            } else if (updatedResult.nModified) {
                var emailTemplateData = {
                    token: tokenGenerated,
                    host: config.HostName,
                    invitedthrough: "register",
                    roomid: "",
                    members: "",
                    userid: "",
                };
                if (validator.isEmail(loginKey) == true) {
                  emailService.mailSender("", loginKey, tokenGenerated, 'validateDevice' , emailTemplateData, function(result) {
                      log.info('Email send status:' + result);
                  });
                }
                else {
                  smsService.sendSMS(loginKey, emailTemplateData, function(smsStatus) {
                      log.info('resendOTP:SMS send status:' + smsStatus);
                  });
                }
                log.info("reSendOTP: resent OTP succesfully!");
                res.status(200).json({
                    "status": "resent OTP successfully",
                    'loginkey': loginKey
                });
            } else {
                log.info("reSendOTP: resend OTP update failed!");
                res.status(400).json({
                    "status": "resend OTP update failed",
                    'loginkey': loginKey
                });
            }
        });
    } catch (err) {
        log.error("reSendOTP:error in reSendOTP:" + err);
        res.status(500).json({
            'status': "server error in reSendOTP",
            'loginkey': loginKey
        });
    }
}


deviceUpdate = function(userid, query, callback) {
    try {
        log.info("The updating divceinfo for userid:" + userid);
        db.profiles.update({
            'userId': userid
        }, query, function(err, result) {
            if (err) {
                log.info("update deviceinfo failed for userid:" + userid);
                callback(err);
            } else {
                if (result == null) {
                    log.info('No Matching recoed to update for userid:' + userid);
                } else {
                    log.info("The results are:" + result);
                    callback(result);
                }
            }
        });
    } catch (err) {
        log.error("Exception in deviceUpdate:" + err);
    }
}


checkTokenExpiry = function(userid, loginkey, uuId) {
    try {
        db.profiles.findOne({
            'userId': userid
        }, function(err, profile) {
            if (err) {
                log.info("checkTokenExpiry:ERROR in finding profile for userid :" + userid);
            } else if (profile) {
                log.info("checkTokenExpiry:Profile found for :" + userid);
                validateDevice(profile.deviceInfo, uuId, function(deviceStatus, index) {
                    if (deviceStatus && profile.deviceInfo[index].tokenValidated != true) {
                        log.info("The Token expiry has been set for UUID:" + uuId);

                        db.profiles.update({
                            $and: [{
                                loginkey: loginkey
                            }, {
                                'deviceInfo': {
                                    $elemMatch: {
                                        'uuid': uuId
                                    }
                                }
                            }]
                        }, {
                            'deviceInfo.$.tokenValidated': false,
                            'deviceInfo.$.token': "expired"
                        }, function(err, removed) {
                            if (err) {
                                log.info("checkTokenExpiry failed for userid:" + userid);
                            } else {
                                if (removed == null) {
                                    log.info('checkTokenExpiry: No Matching record found for userid:' + userid);
                                } else {
                                    log.info("The checkTokenExpiry success :" + removed);
                                }
                            }
                        });
                    }
                });

            } else {
                log.info("checkTokenExpiry:Profile NOT found for :" + userid);
            }
        });

    } catch (err) {
        log.error("Exception in checkTokenExpiry:" + err);
    }
}
CreateSelfRoomData = function(userDetails) {
    try {
        var selfRoomID = "self-" + userDetails.userId;
        var messageDetails = {
            userId: userDetails.userId,
            chatType: "text",
            messsage: config.welcomeMessage,
            timestamp: util.getCurrentTimestamp()
        };
        var roomDetails = {
            groupName: config.AdminGroupName
        };
        var notify = false;
        console.log("creating self room" + selfRoomID, messageDetails, roomDetails, notify);
        checkIfSelfRoomExists(selfRoomID, function(selfRoomExist) {
            if (!selfRoomExist)
                room.createNewSelfRoom(selfRoomID, messageDetails, roomDetails, notify);
        });
    } catch (err) {
        log.error("Exception in creating self room data:" + err);
    }
}
checkIfSelfRoomExists = function(selfRoomID, callback) {
    db.chatGroup.findOne({
        'roomId': selfRoomID
    }, function(err, result) {
        if (err) {
            log.error('Error in getting self room');
        } else {
            if (result == null) {
                log.info('Self Room does not exist');
                callback(false);
            } else {
                log.info('Self Room exist');
                callback(true);
            }
        }
    })
};
module.exports.updateDeviceToken = function(req, res) {
    try {
        var userId = req.body.userid;
        var deviceToken = req.body.devicetoken;
        db.profiles.update({
            'userId': userId
        }, {
            $set: {
                'deviceInfo.0.devicetoken': deviceToken
            }
        }, function(err, result) {
            if (err) {
                log.info('Error in updating devicetoken' + err);
                res.status(500).json({
                    'error': 'Error in updating devicetoken'
                });
            } else {
                log.info('update devicetoken details- result:' + JSON.stringify(result));
                res.status(200).json({
                    'success': 'device token updated successfully'
                });
            }
        });
    } catch (err) {
        log.error("error in updating devicetoken:" + err);
        res.status(500).json({
            'error': 'Error in updating devicetoken'
        });
    }
}
